//  CONTROL.C  = control function, iodes, function keys.
#include	"type.h"  // Functions in this file:
void control (void);          //wait to time; get ionog; save it; display it.
void err_record (char *str, int e2);//make error string & "logit" (file,scrn)
errnum empty (struct iodes *iodesp);//free memory and clear flags.
void cleanit (struct iodes *iodesp);//clean datime, frame, bot,..
void beep (void);             		//beep.
void panic (char *s, int status);   //Log s, close log, free mem, & terminate.
void logit (char *s);               //write date, s to logfile; & s to screen.
void clrkbd(void);                  //clear kbd buffer.
#include	"file.h"
#include	"globals.h"
#include	"errors.h"
#include	"signals.h"
#include   	<stdlib.h>
#include	<stdio.h>
#include    <conio.h>
#include 	<string.h>
#include    <alloc.h>
#include    <dos.h>
#include    <graphics.h>
void control(void)
{// Wait for next scan; GETSCAN gets ionog; SAVE it; DISPLAY it; loop.
	extern errnum getscan(struct iodes *iodesp);
	extern errnum   save (struct iodes *iodesp);
	extern errnum  empty (struct iodes *iodesp);
	extern void  display (struct iodes *iodesp);
	extern int gettimes(byte *time);
	extern int noclean;
	void   clrkbd (void);
	struct date d;
	int e, graf, days_save = 5;		  			//tape save 5days (1-2 MB/day)
	int mins, dmin, icount = 0;
	byte time[7], div, extin;
	buf *bufsav;
	char strng[80];
	gettimes(time);
	graf = 0;
///////////////// This is the main program loop for everything. /////////////
	while ( !kbhit() )
	{ sprintf(strng,"CONTROL() at %02d:%02d.  WAIT to next Sweep-Time(*%d min)"
					" [or kbd]...", time[4], time[5], time_interval );
		if (graf) outtextxy(1, 1, strng);  else printf("\n%s", strng);
		icount +=1;
		for(;;)        	  						// Loop while no key int,
		  {	gettimes(time);                     // checking for next sweeptime
			if ( ((time[5]+1)%time_interval ==time_offset)  	  //at mins-1
				  && (time[6] >= 50) )   break;              	  // & secs=50
			if ( kbhit() )  {
				extin= 255;
				if (getch() ==27)  { closegraph(); exit(0); }	  //esc-> exit
				else break; } 					//other key, get ionogram now
			if ( (extin=inportb(PORTA)&EXTREQ) ==0 ) break; 	  //jackIP Low
		  }//////////////// do scan now
		closegraph();  graf= 0;
		iodesp->flags = 55;										//=32,16,4,2,1
			if (extin==255)  printf("\n  Keyboard Sweep Request: Now.");
			if (extin== 0 )  printf("\n  External Sweep Request: Now.");
		e = getscan(iodesp);			//-- get ionogram, & set time
		if (e != OK)  { err_record("From SCAN()", e);  beep();  break; }
		if (iodesp->rcol < 10)
            { printf("\n No Plot or Save."); delay(3000U);  goto END; }
		iodesp->flags = 57;    									  //=32,16,8,1
		if(debug) printf("  Saving data;  then Display.\n");
		mins = iodesp->minute;
        dmin = time_interval/2;          //def= --CLEAN-- except on hour dmin
		if (dmin>40 && icount>1) dmin = 0;			 //manual, clean after 1st
		if (noclean != 0)  dmin = 0;                                //do clean
		if (noclean == 1)  dmin = 99;                               //no clean
		if (noclean>1 && mins%(noclean*time_interval)==0) dmin= 99; //no clean
//		if (time_interval>90) dmin= 1;   						// leave on hr
		bufsav= iodesp->bufp;		   //must restore for empty(below,-> free)
		if (mins>dmin && mins<(60-dmin))  cleanit(iodesp);		 //clean ionog
		e = save(iodesp);               						  //save ionog
		if (e) { err_record("From SAVE()", e);
				 printf(":  COMPACT Overflow");	 delay(2000U); }
		delay(3000U);
		display(iodesp);  graf= 1; 								  //show ionog
        getdate(&d);               
        if ( (int)d.da_day != day )         //day change (day,mon,yr=filename)
		  {	closegraph();  graf= 1;					 	//new day  -> new file
            if ( (int)d.da_day < day )  exit(2);        //new mon, files->tape
            if (day%days_save>0 || day>28)  exit(1);    //normal day, new file
            exit(2);  }                                 //day=5,10,,25; ->tape
END:    iodesp->bufp= bufsav;
		empty(iodesp);
}	}//end control

void err_record(char *str, int e2)  	// Error recording in Logit()
{	void logit(char *s);
	char *ss,*errstr;
	errstr= (char*)malloc(50);
	ss = (char*)malloc(10);
	strcpy(errstr, str);
	strcat(errstr,", Error: ");
	itoa ( e2, ss, 10);
	strcat(errstr, ss);
	logit(errstr);  free(errstr);  free(ss);
}//end err_record

errnum empty( iodesp )     	// Free buffer memory, clear iodesp flags.
struct iodes *iodesp;
{	if ( iodesp->bufp != NULL )  free( iodesp->bufp );
	iodesp->bufp = NULL;
	iodesp->lcol = 1;
	iodesp->rcol = 577;
	iodesp->height= 64;
	iodesp->flags = 0;
	iodesp->age = 0;
	return( OK );
}//end empty

void beep(void)    { sound(400);  delay(1000u);  nosound(); }

// Log message ( s ), close log, free memory, and terminate.
void panic( s, status )
char *s;
int status;
{	extern errnum empty(struct iodes *iodesp);
	int i;
	logit( s );
	fclose( stderr );
	empty( iodesp );
	exit( status );
}//end panic

void logit(s)     	// Write date, time & message ( s ) to log file.
char *s;            // & write message to screen.
{	extern int gettimes(byte *time);
	byte time[7];  int yr;
	yr = gettimes( time ) - 1900;
	fprintf( stderr, "%2d/%02d/%02d  ",  time[3], time[2], yr );
	fprintf( stderr, "%02d:%02d:%02d  ", time[4], time[5], time[6] );
	fprintf( stderr, "%s\n", s );
	printf("\n%s",s);
}//end logit

void clrkbd(void)	{ while (kbhit())  getch(); }
//end clrkbd
