// ERRORS.H.  Return values from "errno" and "yesno" functions.       14.4.93
#define OK          0   // No_error return from "errno" function.
#define TRUE        1   // Return value from "YESNO" functions.
#define FALSE       0   // Return value from "YESNO" functions.

// Miscellaneous
#define ABORT       0   // used in exit() call of panic().
#define RESTART     1   // used in exit() call of panic().
#define MAXERRORS   10  // Number of re-tries before giving up.
#define MMARGIN     16  // Add to uncertain malloc's for safety.

// Errors related to initial control part.   1 - 9.
#define EQUIT       4   // Soft error: user aborted some func.
#define EDATE       5   // Illegal date given to setdate() <time 103>.
#define ETIME       6   // Illegal time given to setdate() <time 110>.
#define ENOTIME     7   // Time file is not created or creatable<time 137,38>.
#define EBADTIME    8   // Time file is corrupted <time 123,27>.

// Errors from hardware (data collection) part. 10 - 39
#define EISDEAD     10  // Signals fail in SOUNDS.ASM,  amplified by:
       ////ernum=   11: initial Y was high.      12: Y stays low.
       ////      13,14: DataRdy stays Low,High.  15: DataRdy stops toggling.
#define EDEAD       20  // Signals dead <from waithi, waitlo>
#define ESTARTED    21  // Y high on entry to sound (data already started?)
#define EISHIGH     22  // Signal is already high <waithi, from time.33>
#define EISLOW      23  // Y signal already low <waitlow; time38, scan80,113>
#define ESRATE      24  // Illegal sample rate (height) given to getscan.

// Errors from data storage and retrieval part. 40 - 59
#define ENODAT      40  // No ionogram data file (bad open) <disk1,2>
#define EBADDAT     41  // File exists but is corrupt.
#define EFULL       42  // Datfile is (already) full.
#define ENOWRITE    43  // Can't write to data file.
#define EINUM       44  // Requested ionogram number too large.
#define EDISP       45  // Illegally short disp byte, expand().
#define ETRIM       46  // File has been trimmed (recheck); or no ionograms.
#define ENEW        47  // "Soft" errors: new current file made,
#define ECURRENT    48  // This is current file.
#define EDISK       50  // Can't make data file.

// Errors from data processing and presentation.  60 - 69
//// Expect about nil of these; if an ionogram exists, it can be processed.
// Errors from data presentation part.   70 - 79
//// Expect a few printer errors eventually - nothing else.

