//SAVCOM.C  COMPACT & SAVE ionog to file.  .
// HCOPY, HWRITE  to  copy, write  file or ionog header.
#include	"type.h"
#include    <stdio.h>
#include    <dos.h>
errnum hwrite(struct ihead *hp, FILE *ptr, long off);
errnum save( struct iodes *iodesp);  		//save ionog to file *ptr.
void hcopy( buf *dst, buf *src);      //copy header or buffer. NOT USED-
///hcopy ERROR with compact model: iodesp starts with bufp = far = 4 bytes!!
int compact(buf *dest, buf *source, unsigned dsize, unsigned ssize);
#include	"errors.h"
#include	"globals.h"
#include	"file.h"
#include    <alloc.h>
#include    <stdlib.h>
#include	<math.h>
#include    <mem.h>
#define	   DSIZE 18000U 	// max size of COMPACTED file buffer(actual=dsize)

void hcopy( dst, src ) //Copy data from one header/buffer to another, both size HSIZE.
buf *dst, *src;   { memcpy(dst, src, HSIZE);  }

// Write header for file or ionogram (same size).  Being the important
// bit, keep trying if errors are incurred.  Not really necessary I guess.
errnum hwrite( hp, ptr, off )
struct ihead *hp;
FILE *ptr;
long off;
{ 	int n = 0;
	if ( fseek( ptr, off, 0) == -1)  return( EBADDAT );
	while (fwrite(hp,HSIZE,1,ptr) != 1)
	  {	if ( ++n > MAXERRORS )       return( ENOWRITE );
		if (fseek(ptr,off,0) == -1)  return( EBADDAT );  }
	return( OK );
}//end hwrite

// Save ionogram pointed to by iodesp.  Use compact() to reduce size.
// {Find EOF, write ionog header, write compacted data, update file header}.
errnum save( iodesp )	//called from CONTROL(57)
struct iodes *iodesp;
{	extern int compact(buf *dest, buf *source, unsigned dsize, unsigned ssize);
	FILE *ptr;
	struct ihead ip;
	struct fhead fp;
	buf *diskbuf;
	int ncol, nht, mion, i, er = 0;
	long off, length;
	unsigned int count, dsize, ssize;
	buf *bp, *sp, *dp;
	ncol= iodesp->rcol - iodesp->lcol + 1;					// # cols to save
	nht = iodesp->height; 									// bytes per col
	bp  = iodesp->bufp;
	ssize= ncol*nht;
	if ((dsize=ssize/2) >DSIZE) dsize= DSIZE;	  	///assume >50% compaction
	if ( (diskbuf = (unsigned char*) malloc(dsize)) == NULL ) {
		printf("\nSAVE: Insufficient memory for %u-byte buffer", dsize);  exit(0); }
	for (count=0; count<dsize; ++count) *(diskbuf+count)= 0x00;		//zero all
	mion = compact(diskbuf, bp, dsize, ssize);		//compact from bp to diskbuf
		if (mion<=9) { printf(". No Save. ");  er=ENOWRITE; goto end; }
// 				Open file, get file header in *fp.  Copy ionog header to *ip.
	if ( (ptr= fopen( datfile, "r+b"))== NULL )    {  er=ENODAT;  goto end; }
	if ( fread(&fp,HSIZE,1,ptr) !=1 )  { fclose(ptr); er=EBADDAT; goto end; }
///////error, iodes->bufp= 4 bytes w large model: so copy from 2nd item only
//	hcopy( (buf *)&ip, (buf *)iodesp );  -->
		sp = (buf *)&iodesp->lcol;	dp = (buf *)&ip.ilcol;
		for ( i = 0; i < 14; i++ )  *dp++ = *sp++;
// 						Update ionog header(number,size,flags) & write to file.
	ip.inum = ++fp.fnum;
	ip.isize = mion;
	ip.iflags &= 0x3F; //DISKFLAGS;  //= 3F, clear top 2 bits ('inuse', 'lock')
	off = fp.fsize;
	if ( (er = hwrite( &ip, ptr, off )) != 0 )      //write header
	  {	printf("\ner = %d on first entry to hwrite()",er); 	//error:
		fclose( ptr );
		if ( (ptr= fopen(datfile,"r+b")) == NULL ) { er=ENODAT; goto end; }
		fp.fflags = 0x01;
		hwrite((struct ihead *)&fp, ptr, 0L);               //retry
		fclose(ptr);
		printf("\nGot error from hwrite");
		er= EFULL; goto end; }
// 						Write compacted ionog data to file.
	if ( fwrite( diskbuf, BLKSIZE, mion, ptr ) != mion )     //write data
	  {	fclose( ptr );
		if ( (ptr= fopen(datfile,"r+b")) == NULL ) { er=ENODAT; goto end; }
		fp.fflags = 0x01;                              //error: retry
		hwrite((struct ihead *)&fp, ptr, 0L);
		fclose( ptr );
		er=ENOWRITE; goto end; }
// 						Update file header and close
	fp.fsize += ( (long) mion << BLKSHFT ) + LHSIZE;
	er = hwrite((struct ihead *) &fp, ptr, 0L );
	fclose( ptr );
	if (er != 0)
	  {	if ( (ptr= fopen(datfile,"r+b")) == NULL )  { er=ENODAT; goto end; }
		fp.fflags = 0x01;
		hwrite((struct ihead *)&fp, ptr, 0L);
		fclose( ptr );  }
	iodesp->flags &= 0xDF;
	if ( (ptr= fopen("last.ion", "w")) != NULL )		 //save in "last.ion"
	  { fp.fsize = mion + 32;	ip.inum = fp.fnum = 1;
		hwrite((struct ihead *)&fp, ptr, 0L);
		hwrite(&ip, ptr, 16L);
		fwrite(diskbuf, BLKSIZE, mion, ptr );
		fclose( ptr );  }
end: free(diskbuf);  return( er );
}//end save.  ret to control.

//compact with #zeros between echos.   ///added dsize= max buffer bytes.
//A non-zero byte is saved.
//A zero byte is saved, followed by count of # of following zero bytes.
///Qualtrough original (in crunch.asm) counts bits.   Bytes:  1.......=data;
///00...... = count (1-63) of #zeros;   01...... = byte1 of 2-byte zerocount.
int compact(buf *dest, buf *source, unsigned dsize, unsigned ssize)
{	unsigned int total_bytes, d, zero_count; 	///'buf' = unsigned char
	buf *src, *dst, *smax, *dmax;
	src = source;  smax = src + ssize;     	  // start, end  of full ionogram
	dst = dest;    dmax = dst + dsize;   	  // dest,max for compacted output
	for (;;)
	{	if (src >= smax)  break;			//(all done) /(ret 1 on overflow)
		if (dst+2 >=dmax)  { printf("\nCOMPACT: full!");  return(1); }
		*(dst) = *(src++);    				// Store next byte,      (inc s)
		if ( *(dst++) == 0x00)       		// if it was zero-    	 (inc d)
		  {	zero_count = 1;
			while ( *(src) == 0x00)			//-if next = 0,
			  {	++zero_count;                   	// -count #zero bytes
				if (++src >= smax)   break;  		//  inc src   (all done)
				if (zero_count==255) break;	}		//      (max # to store)
			*(dst++) = zero_count;         			//-store count(1-byte??)
		  }//end zero-count bytes & store #.
	}//all bytes done.   src, dst point at NEXT byte
	*(dst++) = 0;  *(dst++) = 0;									//flag end
	d = dst - dest;
///	  if ( d<999 || d+99>dsize) {
	printf("COMPACT %u to %u bytes. ", src-source,d);  ///delay(3000U); ///}
	return((int)ceil((double)d /16.0));///ret size in 16-byte blocks (1=o'flo)
}//end compact.  ret to save.
